#include <windows.h>
#include <mmsystem.h>
#include "nMail.h"

#define MAX_BUF       8192
#define MAX_ACCOUNT   20

HANDLE hf;
char mtmp_str[1000], nomail_str[1000], sep_str[1000];

typedef struct{
  char newmail[100];
  char nomail[100];
} USRSTR;

void add_title(char *path, char *title)
{
  char *p;

  p = path;

  if(*p == 0) ;
  else if(*title && *(title + 1) == ':') ;
  else if(*title == '\\')
    {
      if(*p && *(p + 1) == ':') p += 2;
    }
  else
    {
      while(*p)
        {
          if((*p == '\\' || *p == '/') && *(p + 1) == 0)
            {
              break;
            }
          p = CharNext(p);
        }
      *p++ = '\\';
    }
  while(*title) *p++ = *title++;
  *p = 0;
}

void del_title(char *path)
{
  char *p, *ep;

  p = ep = path;
  while(*p)
    {
      if(*p == '\\' || *p == '/')
        {
          if(p > path && *(p - 1) == ':') ep = p + 1;
          else ep = p;
        }
      p = CharNext(p);
    }
  *ep = 0;
}

void OpenDataFile(char* outfile, char* mydir)
{
  char fpath[1024];

  strcpy(fpath,mydir);
  add_title(fpath,outfile);
  hf = CreateFile(fpath, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, //TRUNCATE_EXISTING,
                  FILE_ATTRIBUTE_NORMAL,  NULL);
  if (hf == INVALID_HANDLE_VALUE)
    {
      MessageBox(0, "݃t@CJ܂B", "G[", MB_OK);
      CloseHandle(hf);
      ExitProcess(0);
    }
}

void CloseDataFile(void)
{
  CloseHandle(hf);
}

void WriteText(char* s)
{
  DWORD dw = 0;
  WriteFile(hf, s, lstrlen(s), &dw,NULL);
}

BOOL GetText(PSTR pszText, char* mydir)
{
  HANDLE	hFile;
  char	fpath[1024];
  DWORD	dwReadSize;
  DWORD	dwFileSize;

  if(!pszText)
    return FALSE;

  strcpy(fpath,mydir);
  add_title(fpath,pszText);
  strcpy(pszText, "");

  hFile = CreateFile(fpath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
  if(hFile == INVALID_HANDLE_VALUE)
    return FALSE;
  dwFileSize = GetFileSize(hFile, NULL);
  ReadFile(hFile, pszText, dwFileSize, &dwReadSize, NULL);
  CloseHandle(hFile);

  if(strcmp(pszText, "") == 0)
    return FALSE;

  pszText[dwFileSize] = '\0';
  return TRUE;
}

BOOL GetNumFormat(char **sp, char x, int *len, int *slen)
{
  char *p;
  int n, ns;

  p = *sp;
  n = 0;
  ns = 0;

  while (*p == '_')
    {
      ns++;
      p++;
    }
  if (*p != x) return FALSE;
  while (*p == x)
    {
      n++;
      p++;
    }

  *len = n+ns;
  *slen = ns;
  *sp = p;
  return TRUE;
}

void SetNumFormat(char **dp, int n, int len, int slen)
{
  char *p;
  int minlen,i;

  p = *dp;

  for (i=10,minlen=1; i<1000000000; i*=10,minlen++)
    if (n < i) break;

  while (minlen < len)
    {
      if (slen > 0) { *p++ = ' '; slen--; }
      else { *p++ = '0'; }
      len--;
    }

  for (i=minlen-1; i>=0; i--)
    {
      *(p+i) = (char)((n%10)+'0');
      n/=10;
    }
  p += minlen;

  *dp = p;
}

void MakeFormat(char* s, char* fmt, int accountNo, int cnt, char* subj, char* date, char* from, char* body)
{
  char *sp, *dp, *p;
  DWORD TickCount = 0;

  sp = fmt; dp = s;
  while(*sp)
    {
      if(*sp == '\'')
        {
          sp++;
          while(*sp != '\'' && *sp)
            {
              p = CharNext(sp);
              while(sp != p) *dp++ = *sp++;
            }
          if(*sp == '\'') sp++;
        }
      else if( strncmp(sp, "NO", 2) == 0 )
        {
          int len, slen;
          sp +=2;
          if(GetNumFormat(&sp, 'x', &len, &slen) == TRUE)
            SetNumFormat(&dp, cnt, len, slen);
          else
            SetNumFormat(&dp, cnt, 2, 2);
        }
      else if( strncmp(sp, "ANO", 3) == 0 )
        {
          int len, slen;
          sp += 3;
          if(GetNumFormat(&sp, 'x', &len, &slen) == TRUE)
            SetNumFormat(&dp, accountNo, len, slen);
          else
            SetNumFormat(&dp, accountNo, 2, 2);
        }
      else if( strncmp(sp, "SUBJ", 4) == 0 )
        {
          sp += 4;
          if (subj[0] != 0)
            {
              p = subj;
              while(*p) *dp++ = *p++;
            }
        }
      else if( strncmp(sp, "DATE", 4) == 0 )
        {
          sp += 4;
          if (date[0] != 0)
            {
              p = date;
              while(*p) *dp++ = *p++;
            }
        }
      else if( strncmp(sp, "FROM", 4 ) == 0 )
        {
          sp += 4;
          if (from[0] != 0)
            {
              p = from;
              while(*p) *dp++ = *p++;
            }
        }
      else if( strncmp(sp, "BODY", 4) == 0 )
        {
          sp += 4;
          if (body[0] != 0)
            {
              p = body;
              while(*p) *dp++ = *p++;
            }
        }
      else if(*sp == '\\' && *(sp + 1) == 'n')
        {
          *dp++ = 0x0d; *dp++ = 0x0a;
          sp += 2;
        }
      else
        {
          p = CharNext(sp);
          while(sp != p) *dp++ = *sp++;
        }
    }
  *dp = 0;
}

int list_mail(SOCKET s, char *host, char *id, char *pass, int accountNo, int maxget, int bodyget, BOOL apopFlag)
{
  int count, max, get;
  char subject[MAX_BUF], date[MAX_BUF], from[MAX_BUF], header[MAX_BUF], body[MAX_BUF];
  char str[MAX_BUF];

  MakeFormat(str,sep_str,accountNo,0,"subj","date","from","body");
  WriteText(str);
  WriteText("\r\n");

  // F؂đ[擾
  if((max = NMailPop3Authenticate(s, id, pass, apopFlag)) > 0) {
    if (max < maxget)
      maxget = max;
    for(count = 0 ; count < maxget ; count++) {
      get = max - count;

      // e[̏擾
      if( bodyget == 1 ){
        if(NMailPop3GetMail(s, get, subject, date, from, header, body, NULL, NULL) >= 0) {
          MakeFormat(str,mtmp_str,accountNo,get,subject,date,from,body);
          WriteText(str);
        } else {
          lstrcpy(str,"error1\r\n");
          WriteText(str);
          break;
        }
      } else {
        if(NMailPop3GetMailStatus(s, get, subject, date, from, header, FALSE) >= 0) {
          MakeFormat(str,mtmp_str,accountNo,get,subject,date,from,body);
          WriteText(str);
        } else {
          lstrcpy(str,"error2\r\n");
          WriteText(str);
          break;
        }
      }
    }
  }
  else if ( max == 0 ) {
    WriteText(nomail_str);
    WriteText("\r\n");
  }
  return max;
}

void __cdecl WinMainCRTStartup( void )
{
  SOCKET s;
  HINSTANCE hInst;
  HANDLE hfind;
  WIN32_FIND_DATA fd;
  BOOL bBlink, bUsrStr, bSuccess = FALSE;
  USRSTR u_str[10];
  HWND hwndClock, hwndTray, hwndTaskbar;
  int i, maxget, allmail, blink_t, bodyget, bodymax;
  char fname[1024], mydir[1024], head_str[5000], foot_str[5000], tmp_str[100], outfile[100], soundfile[100], wps[20],
  connErr[1000], authErr[1000];

  // vOPATH擾
  hInst = GetModuleHandle(NULL);
  GetModuleFileName(hInst, mydir, 1024);
  del_title(mydir);

  // init@C邩ǂ
  strcpy(fname, mydir);
  add_title(fname, "chkmail.ini");
  hfind = FindFirstFile(fname, &fd);
  if(hfind != INVALID_HANDLE_VALUE)
    {
      FindClose(hfind);
    }
  else
    {
      MessageBox(NULL,"init@C܂łB","G[",MB_OK);
      ExitProcess(0);
    }

  // ʐݒǂݍ
  GetPrivateProfileString("Main", "File", "chkmail.txt", outfile, 100, fname);
  GetPrivateProfileString("Main", "SoundFile", "", soundfile, 100, fname);
  GetPrivateProfileString("Main", "Header", "", head_str, 5000, fname);
  GetPrivateProfileString("Main", "Footer", "", foot_str, 5000, fname);
  GetPrivateProfileString("Main", "Separator", "", sep_str, 1000, fname);
  GetPrivateProfileString("Main", "NoMail", "V[", nomail_str, 1000, fname);
  GetPrivateProfileString("Main", "MailTemp", "NO SUBJ\r\n   DATE FROM\r\n\r\n", mtmp_str, 1000, fname);
  GetPrivateProfileString("Main", "ConnectErr", "\"------------\"\r\n\"F؃G[IAJEg ANO\"\r\n\"------------\"\r\n", connErr, 1000, fname);
  GetPrivateProfileString("Main", "AuthErr", "\"------------\"\r\n\"ڑG[IAJEg ANO\"\r\n\"------------\"\r\n", authErr, 1000, fname);
  maxget  = GetPrivateProfileInt("Main", "Max", 10, fname);
  bodyget = GetPrivateProfileInt("Main", "BodyGet", 0, fname);
  bodymax = GetPrivateProfileInt("Main", "BodyMax", 500, fname);
  blink_t = GetPrivateProfileInt("Main", "BlinkTime", 30,  fname);
  bBlink  = GetPrivateProfileInt("Main", "Blink", TRUE,  fname);
  bUsrStr = GetPrivateProfileInt("Main", "Ustr", FALSE, fname);

  // [U[`ǂݍ
  for (i=0; i<10; i++)
    {
      char sect[20];

      wsprintf(sect,"USNewMail%d",i);
      GetPrivateProfileString("Main", sect, "", u_str[i].newmail, 100, fname);
      wsprintf(sect,"USNoMail%d",i);
      GetPrivateProfileString("Main", sect, "", u_str[i].nomail, 100, fname);
    }

  // wb_[ƃtb^[ƃevǂݍ
  if(head_str[0] == 'f' && head_str[1] == 'i' && head_str[2] == 'l' && head_str[3] == 'e' && head_str[4] == ':')
    {
      memmove( head_str, head_str + 5, (size_t)((strchr(head_str,'\0')-1)-head_str));
      if(!GetText(head_str,mydir)){
        strcpy(head_str, "\"Headert@C擾s\"");
      }
    }
  if(foot_str[0] == 'f' && foot_str[1] == 'i' && foot_str[2] == 'l' && foot_str[3] == 'e' && foot_str[4] == ':')
    {
      memmove( foot_str, foot_str + 5, (size_t)((strchr(foot_str,'\0')-1)-foot_str));
      if(!GetText(foot_str,mydir)){
        strcpy(foot_str, "\"Footert@C擾s\"");
      }
    }
  if(mtmp_str[0] == 'f' && mtmp_str[1] == 'i' && mtmp_str[2] == 'l' && mtmp_str[3] == 'e' && mtmp_str[4] == ':')
    {
      memmove( mtmp_str, mtmp_str + 5, (size_t)((strchr(mtmp_str,'\0')-1)-mtmp_str));
      if(!GetText(mtmp_str,mydir)){
        strcpy(mtmp_str, "\"ev[gt@C擾s\"");
      }
    }
  if(sep_str[0] == 'f' && sep_str[1] == 'i' && sep_str[2] == 'l' && sep_str[3] == 'e' && sep_str[4] == ':')
    {
      memmove( sep_str, sep_str + 5, (size_t)((strchr(sep_str,'\0')-1)-sep_str));
      if(!GetText(sep_str,mydir)){
        strcpy(sep_str, "\"Zp[^[t@C擾s\"");
      }
    }

  // ݃t@CJ
  OpenDataFile(outfile,mydir);

  // Header
  if (head_str[0] != 0)
    WriteText(head_str);

  for(i=0; i<MAX_ACCOUNT; i++)
    {
      char sect[20], temp_str[1000];
      char host[100], id[50], pass[50];
      int port, cnt, oldCnt, accountNo, useApop;
      BOOL apopFlag = FALSE;

      accountNo = i + 1;

      // AJEgʐݒǂݍ
      wsprintf(sect,"Mail%d",accountNo);
      if (!(GetPrivateProfileInt(sect, "On", FALSE, fname)))
        continue;
      GetPrivateProfileString(sect, "Host", "", host, MAX_BUF, fname);
      GetPrivateProfileString(sect, "ID",   "", id,   MAX_BUF, fname);
      GetPrivateProfileString(sect, "Pass", "", pass, MAX_BUF, fname);
      port   = GetPrivateProfileInt(sect, "Port", 110, fname);
      oldCnt = GetPrivateProfileInt(sect, "Cnt", 0, fname);
      useApop = GetPrivateProfileInt(sect, "APOP", 0, fname);
      if( useApop )
        apopFlag = TRUE;
      
      // [M
      NMailSetOption(NMAIL_OPTION_TIMEOUT,30);
      NMailSetOption(NMAIL_OPTION_HEADER_MAX,MAX_BUF);
      NMailSetOption(NMAIL_OPTION_BODY_MAX,bodymax);
      NMailInitializeWinSock();

      // [M
      if((s = NMailPop3ConnectPortNo(host,port)) != INVALID_SOCKET) {
        if((cnt=list_mail(s, host, id, pass, accountNo, maxget, bodyget, apopFlag)) >= 0)
          {
            NMailPop3Close(s);
            if (cnt != oldCnt && cnt > 0 && oldCnt < cnt)
              {
                allmail += cnt - oldCnt;
                bSuccess = TRUE;
              }
            if (cnt != oldCnt && cnt > 0 && oldCnt > cnt)
              {
                allmail += cnt;
                bSuccess = TRUE;
              }
          }
        // F؃G[
        else {
          MakeFormat(temp_str,authErr,accountNo,0,"subj","date","from","body");
          WriteText(temp_str);
        }
        wsprintf(wps, "%d", cnt);
        WritePrivateProfileString(sect, "Cnt", wps, fname);
        // ڑG[
      } else {
        MakeFormat(temp_str,connErr,accountNo,0,"subj","date","from","body");
        WriteText(temp_str);
      }

      // MI
      NMailEndWinSock();
    }

  // Footer
  if (foot_str[0] != 0)
    WriteText(foot_str);

  // f[^t@C
  CloseDataFile();

  // TClockT
  hwndTaskbar = FindWindow("Shell_TrayWnd", "");
  hwndTray = FindWindowEx(hwndTaskbar, NULL, "TrayNotifyWnd", "");
  hwndClock = FindWindowEx(hwndTray, NULL, "TrayClockWClass", NULL);

  // [U[`񑗐M
  if (bUsrStr)
    {
      // [U[񑗐M
      for (i=0; i<10; i++)
        {
          COPYDATASTRUCT  cds;
          if (u_str[i].newmail[0] == 0 && u_str[i].nomail == 0)
            continue;
          if (bSuccess)
            MakeFormat(tmp_str,u_str[i].newmail,0,allmail,"subj","date","from","body");
          else
            MakeFormat(tmp_str,u_str[i].nomail,0,allmail,"subj","date","from","body");
          cds.dwData = i;
          cds.lpData = (void*)tmp_str;
          cds.cbData = lstrlen(tmp_str) + 1;
          SendMessage( hwndClock, WM_COPYDATA, (WPARAM)NULL, (LPARAM)&cds );
        }
      // TClockɍĕ`悳
      PostMessage(hwndClock,WM_USER+1,0,0);
    }

  // V肾ꍇ̏
  if (bSuccess)
    {
      if (bBlink)
        SendMessage(hwndClock,WM_USER+3,0,0);
      if (soundfile[0] != 0)
        {
          strcpy(fname, mydir);
          add_title(fname, soundfile);
          PlaySound(fname, NULL, SND_FILENAME | SND_SYNC);
        }
      if (blink_t > 0)
        {
          Sleep(blink_t*1000);
          PostMessage(hwndClock,WM_USER+3,0,TRUE);
        }
    }

  // I
  ExitProcess(0);
}
